%%% Smith-Purcell simulations for SPARC

%sum_tr=cell(100);

set(0,'DefaultAxesFontSize',22)
%set(gca,'FontSize',16)

colors={ ':b', '.-g' , '--r' , 's-m', 'o-c', '+:k' , '-y' };

el_mm_vals=[ 2 3 4 6 8 10];
%el_mm_vals=[ 2 3 4 5 6 7 8 ];
gamma_vals=70;
gamma_vals_multi=[ 70 ];
x0_mm_vals_multi=[ 7 ];
%epsl_vals=[1 2 5 10];
epsl_vals=[1 2 5 7 10 ];
%gamma_vals_multi=[ 200  ];
%x0_mm_vals_multi=[ 1 ];
x0_mm_vals=1;
pulse_len_ps_vals=[ 5 ];

el_mm=el_mm_vals(1);
gamma=gamma_vals(1);
x0_mm=x0_mm_vals(1);
pulse_len_ps=pulse_len_ps_vals(1);

%warning('Comment the next line if you do not want to reinitialise')
%run_done=[]

for epsl_loop=1:length(epsl_vals)
    epsl=epsl_vals(epsl_loop);
    for el_loop=1:length(el_mm_vals)
        el_mm=el_mm_vals(el_loop);
        for pulse_loop=1:length(pulse_len_ps_vals)
            pulse_len_ps=pulse_len_ps_vals(pulse_loop);
            if ((el_mm==1)&&(pulse_len_ps==0.3))
                %            gamma_vals=gamma_vals_multi;
                x0_mm_vals=x0_mm_vals_multi;
            else
                x0_mm_vals=x0_mm_vals_multi(1);
            end %if gamma
            for gamma_loop=1:length(x0_mm_vals)
                %           gamma=gamma_vals(gamma_loop);
                x0_mm=x0_mm_vals(gamma_loop);
                irun=el_loop+10*pulse_loop+100+1000*(gamma_loop-1)+10000*epsl_loop
                if (isempty(find(run_done==irun)))
                    sum_tr{irun}=0
                    [nu_Hz{irun},SP_spec_1{irun},SP_spec_N{irun},lam{irun},E_total{irun},sum_tr{irun},thet]=GFWnew(['lgr_mm=200;wid_mm=100;el_mm=' num2str(el_mm) ';alpha1=30;Qbunch_nC=0.01;PrSelect=2;x0_mm=' num2str(x0_mm) ';fwhm_x_mm=0.5;fwhm_y_mm=0.5;pulse_len_ps=' num2str(pulse_len_ps) ';gam=' num2str(gamma) ';epsl=' num2str(epsl) ';ThetaDiv=80;phiDiv=3;PlotFunc=[1 1 1 1 1]'])
                end % we run only if needed
                run_done=[ run_done irun]
            end %gamma_loop
        end % pulse_loop
    end % epsl_loop
end

gamma_loop=1;
epsl_loop=1;
for el_loop=1:length(el_mm_vals)
    legend_txt={};
    figure(700+el_loop)
    clf
    hold on
    title([ 'Grating pitch (mm) ' num2str(el_mm_vals(el_loop)) ' gamma = ' num2str(gamma_vals(gamma_loop)) ] )
    for pulse_loop=1:length(pulse_len_ps_vals)
        irun=el_loop+10*pulse_loop+100*gamma_loop+10000*epsl_loop;
        length(sum_tr{irun})
        plot(thet,sum_tr{irun},colors{pulse_loop})
        legend_txt{pulse_loop}= [ 'Pulse len.= ' num2str(pulse_len_ps_vals(pulse_loop)) ' ps ' ];
        grid on
    end %for
    legend(legend_txt);
    xlabel('Observation angle (degree)');
    ylabel('Signal Intensity (J)');
    print('-dpng',[ '/Users/delerue/travail/plasma/DACTOMUS/SP_at_DACTOMUS/pulse_length_comparison_pitch_' num2str(el_mm_vals(el_loop)) '.png' ] );
end %for

for epsl_loop=1:length(epsl_vals)
    legend_txt={};
    figure(700+20+epsl_loop)
    clf
    hold on
    title([ 'Grating pitch (mm) ' num2str(el_mm_vals(el_loop)) 'epsl=' num2str(epsl_vals(epsl_loop)) ' gamma = ' num2str(gamma_vals(gamma_loop)) ] )
    for pulse_loop=1:length(pulse_len_ps_vals)
        irun=el_loop+10*pulse_loop+100*gamma_loop+10000*epsl_loop;
        plot(thet,sum_tr{irun},colors{pulse_loop})
        legend_txt{pulse_loop}= [ 'Pulse len.= ' num2str(pulse_len_ps_vals(pulse_loop)) ' ps ' ];
        grid on
    end %for
    legend(legend_txt);
    xlabel('Observation angle (degree)');
    
    ylabel('Signal Intensity (J)');
    print('-dpng',[ '/Users/delerue/travail/plasma/DACTOMUS/SP_at_DACTOMUS/pulse_length_comparison_pitch_' num2str(el_mm_vals(el_loop)) '.png' ] );
end %for

for pulse_loop=1:length(pulse_len_ps_vals)
    for iloop=1:2
    legend_txt={};
        figure(700+10*pulse_loop+1000*iloop)
        clf
        hold on
        title( [ 'Pulse length ' num2str(pulse_len_ps_vals(pulse_loop)) ' ps'  ' gamma = ' num2str(gamma_vals(gamma_loop)) ] )
        if (iloop==1)
            epsl_loop=3
            for el_loop=1:length(el_mm_vals)
                irun=el_loop+10*pulse_loop+100+1000*(gamma_loop-1)+10000*epsl_loop
                plot(thet,sum_tr{irun},colors{el_loop},'linewidth',2)
                grid on
                set(gca,'FontSize',22)
%                legend_txt{el_loop}= [ 'Pitch= ' num2str(el_mm_vals(el_loop)) ' mm - Asym. = ' num2str(epsl_vals(1)) ];
                legend_txt{el_loop}= [ 'Pitch= ' num2str(el_mm_vals(el_loop)) ' mm' ];
                xlim([30 155])
            end %for
        else
            %iloop==2
            el_loop=3
            for epsl_loop=1:length(epsl_vals)
                irun=el_loop+10*pulse_loop+100+1000*(gamma_loop-1)+10000*epsl_loop
                plot(thet,sum_tr{irun},colors{epsl_loop})
                grid on
                legend_txt{epsl_loop}= [ 'Pitch= ' num2str(el_mm_vals(el_loop)) ' mm - Asym. = ' num2str(epsl_vals(epsl_loop)) ];
            end %for
        end % if iloop
        legend(legend_txt);
        xlabel('Observation angle (degree)');
        ylabel('Signal Intensity (J)');
        print('-dpng',[ '/Users/delerue/travail/smith-purcell/CLIO/simulations/pitch_comparison_pulse_' num2str(pulse_len_ps_vals(pulse_loop)) num2str(iloop) '.png' ] );
        print('-depsc',[ '/Users/delerue/travail/smith-purcell/CLIO/simulations/pitch_comparison_pulse_' num2str(pulse_len_ps_vals(pulse_loop)) num2str(iloop) '.eps' ] );
    end %for iloop 1:2
end % for pulse length    
    %  pulse_loop=3;
    %  el_loop=3;
    %     figure(800)
    %     clf
    %     hold on
    %     title( [ 'Pulse length ' num2str(pulse_len_ps_vals(pulse_loop)) ' ps - '  'Pitch= ' num2str(el_mm_vals(el_loop)) ' mm '  ] )
    %     legend_txt={};
    
    figure(800)
    
    for gamma_loop=1:length(gamma_vals_multi)
        irun=el_loop+10*pulse_loop+100+1000*(gamma_loop-1)+10000*epsl_loop
        irun
        length(sum_tr{irun})
        plot(thet,sum_tr{irun},colors{gamma_loop})
        grid on
        legend_txt{gamma_loop}= [ 'gamma= ' num2str(gamma_vals_multi(gamma_loop)) ];
    end %for
    legend(legend_txt);
    xlabel('Observation angle (degree)');
    ylabel('Signal Intensity (J)');
    print('-dpng','/Users/delerue/travail/plasma/DACTOMUS/SP_at_DACTOMUS/gamma_comparison.png');
    
    % pulse_loop=3;
    %  el_loop=3;
    %     figure(801)
    %     clf
    %     hold on
    %     title( [ 'Pulse length ' num2str(pulse_len_ps_vals(pulse_loop)) ' ps - '  'Pitch= ' num2str(el_mm_vals(el_loop)) ' mm '  ] )
    %     legend_txt={};
    
    for x0_loop=1:length(x0_mm_vals_multi)
        irun=el_loop+10*pulse_loop+100+1000*(gamma_loop-1)+10000*epsl_loop
        irun
        length(sum_tr{irun})
        plot(thet,sum_tr{irun},colors{x0_loop})
        grid on
        legend_txt{x0_loop}= [ 'x0= ' num2str(x0_mm_vals_multi(x0_loop)) ' mm' ];
    end %for
    legend(legend_txt);
    xlabel('Observation angle (degree)');
    ylabel('Signal Intensity (J)');
    print('-dpng','/Users/delerue/travail/plasma/DACTOMUS/SP_at_DACTOMUS/x0_comparison.png');
    
    
